name         = 'kiltera'
version      = '0.4a2'
author       = "Ernesto Posse"
author_email = "eposse@cs.mcgill.ca"
url          = "http://moncs.cs.mcgill.ca/people/eposse/projects/kiltera"
package_dir  = {'': 'src'}
packages     = \
    [
        'kiltera',
        'kiltera.kiltera_syn_cfg',
        'kiltera.kiltera_syn_original_cfg'
    ]
py_modules   = []
scripts      = \
    [
        'src/kiltera/klt.py',
        'src/kiltera/kltserver.py',
        'klt',
        'kltserver'
    ]

import os
tests = ['tests/%s' % test for test in os.listdir('tests')]

data_files = \
    [
        ('kiltera_examples',tests)
    ]
description  = 'kiltera: a language for concurrent, mobile, real-time systems.'

postinstall_script = 'klt_postinstall.py'
executables        = \
    [
        ('klt.py', 'klt'),
        ('kltserver.py', 'kltserver')
    ]
dependencies       = [('aperiot', '0.1.2')]
