
import aperiot.lexer


# Non-terminal symbol names

MODULE_27_117_197_222 = 'MODULE_27_117_197_222'
ACTION = 'ACTION'
BODY = 'BODY'
BTERM_51 = 'BTERM_51'
PROCESS = 'PROCESS'
PARENTH_FORM_47_108 = 'PARENTH_FORM_47_108'
PARENTH_FORM_47 = 'PARENTH_FORM_47'
LITERAL = 'LITERAL'
BATOM_52 = 'BATOM_52'
AFACTOR = 'AFACTOR'
NESTED_PROC = 'NESTED_PROC'
PROCESS_70 = 'PROCESS_70'
COMMUNICATION_78_92_179_235 = 'COMMUNICATION_78_92_179_235'
COMMUNICATION = 'COMMUNICATION'
PROCESS_67_132_194_211_247 = 'PROCESS_67_132_194_211_247'
IMPORTS = 'IMPORTS'
AEXPR_19 = 'AEXPR_19'
BINDINGS_5_115_148 = 'BINDINGS_5_115_148'
DEF_LIST = 'DEF_LIST'
BFACTOR = 'BFACTOR'
EXPR = 'EXPR'
EXPR_CASE_LIST_10_94_175 = 'EXPR_CASE_LIST_10_94_175'
RELATION = 'RELATION'
PORT_LIST = 'PORT_LIST'
MODULE = 'MODULE'
OPT_SEMICOLON = 'OPT_SEMICOLON'
ACTION_16_95 = 'ACTION_16_95'
ACTION_14 = 'ACTION_14'
EXPR_CASES_28_100_174 = 'EXPR_CASES_28_100_174'
CASE_LIST_46_82_198 = 'CASE_LIST_46_82_198'
PROCESS_72_106_151_226 = 'PROCESS_72_106_151_226'
FUNCTION_DEF_54_111_181 = 'FUNCTION_DEF_54_111_181'
ATOM_57 = 'ATOM_57'
ATOM_58 = 'ATOM_58'
PARAMS = 'PARAMS'
EXPR_LIST_24 = 'EXPR_LIST_24'
CONS_LIST_48 = 'CONS_LIST_48'
EXPR_LIST = 'EXPR_LIST'
PROCESS_66_141_149_230_254 = 'PROCESS_66_141_149_230_254'
BEXPR_80 = 'BEXPR_80'
PROCESS_LIST_12_125 = 'PROCESS_LIST_12_125'
NAME_LIST_1 = 'NAME_LIST_1'
ARGS = 'ARGS'
PROCESS_DEF_55 = 'PROCESS_DEF_55'
DEF = 'DEF'
PARENTH_FORM_47_108_158_238_261_282 = 'PARENTH_FORM_47_108_158_238_261_282'
ACTION_15_96 = 'ACTION_15_96'
FUNC_BODY = 'FUNC_BODY'
PROCESS_69 = 'PROCESS_69'
ACTION_14_97_195 = 'ACTION_14_97_195'
IPROCESS_DEF = 'IPROCESS_DEF'
COMMUNICATION_79_93_186_234 = 'COMMUNICATION_79_93_186_234'
NDEF_LIST_0 = 'NDEF_LIST_0'
CASES_17_140_160 = 'CASES_17_140_160'
ATERM_20 = 'ATERM_20'
ATOM = 'ATOM'

rules = \
  {
    MODULE_27_117_197_222: 
      [
        ([], 'module_27_117_197_222'),
        ([Keyword('main'), NESTED_PROC], 'expansion_216'),
      ], 
    ACTION: 
      [
        ([COMMUNICATION], 'expansion_282'),
        ([aperiot.lexer.Identifier, ACTION_14], 'new_action_action_2'),
        ([Keyword('print', 'printkwd'), EXPR, ACTION_15_96], 'expansion_284'),
        ([Keyword('wait'), EXPR, ACTION_16_95], 'expansion_283'),
      ], 
    BODY: 
      [
        ([Bracket('{', 'lbrace'), PROCESS, Bracket('}', 'rbrace')], 'expansion_422'),
        ([PROCESS], 'expansion_421'),
      ], 
    BTERM_51: 
      [
        ([], 'bterm_51'),
        ([Operator('and', 'andop'), BFACTOR, BTERM_51], 'expansion_275'),
      ], 
    PROCESS: 
      [
        ([Keyword('nil')], 'expansion_448'),
        ([Keyword('done')], 'expansion_451'),
        ([ACTION], 'expansion_452'),
        ([Keyword('par', 'parallel'), Bracket('{', 'lbrace'), PROCESS, Separator(';', 'semicolon'), PROCESS, PROCESS_LIST_12_125, Bracket('}', 'rbrace'), PROCESS_66_141_149_230_254], 'expansion_500'),
        ([Keyword('seq', 'sequence'), Bracket('{', 'lbrace'), PROCESS, Separator(';', 'semicolon'), PROCESS, PROCESS_LIST_12_125, Bracket('}', 'rbrace'), PROCESS_67_132_194_211_247], 'expansion_538'),
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_447'),
        ([Keyword('async'), PROCESS_69], 'new_process_action_9'),
        ([Keyword('sync'), PROCESS_70], 'new_process_action_10'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_20, AEXPR_19, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_434'),
        ([Keyword('if', 'ifkwd'), BFACTOR, BTERM_51, BEXPR_80, Keyword('then'), NESTED_PROC, PROCESS_72_106_151_226], 'expansion_368'),
        ([Keyword('let'), aperiot.lexer.Identifier, Operator('=', 'eq'), EXPR, BINDINGS_5_115_148, Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_413'),
        ([Keyword('match'), EXPR, Keyword('with'), EXPR, Operator('->', 'arrow'), NESTED_PROC, CASES_17_140_160], 'expansion_536'),
        ([DEF, NDEF_LIST_0, Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_273'),
        ([Keyword('timeout'), NESTED_PROC, Keyword('after'), EXPR, Operator('->', 'arrow'), NESTED_PROC], 'expansion_489'),
        ([Keyword('do'), NESTED_PROC, Keyword('interrupt'), NESTED_PROC], 'expansion_313'),
      ], 
    PARENTH_FORM_47_108: 
      [
        ([Bracket(')', 'rpar')], 'expansion_485'),
        ([Separator(',', 'comma'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_404'),
        ([Keyword('for', 'forkwd'), EXPR, Keyword('in', 'inkwd'), EXPR, PARENTH_FORM_47_108_158_238_261_282], 'expansion_533'),
        ([Separator(';', 'semicolon'), EXPR, CONS_LIST_48, Bracket(')', 'rpar')], 'expansion_486'),
      ], 
    PARENTH_FORM_47: 
      [
        ([Bracket(')', 'rpar')], 'expansion_57'),
        ([EXPR, PARENTH_FORM_47_108], 'new_parenth_form_47_1'),
      ], 
    LITERAL: 
      [
        ([Operator('unit')], 'expansion_185'),
        ([aperiot.lexer.NumberLiteral], 'expansion_184'),
        ([Operator('true')], 'expansion_189'),
        ([Operator('false')], 'expansion_188'),
        ([aperiot.lexer.StringLiteral], 'expansion_187'),
        ([Keyword('channel', 'channelkwd')], 'expansion_186'),
        ([Keyword('async'), Keyword('channel', 'channelkwd')], 'expansion_191'),
        ([Keyword('sync'), Keyword('channel', 'channelkwd')], 'expansion_190'),
      ], 
    BATOM_52: 
      [
        ([], 'batom_52'),
        ([RELATION, AFACTOR, ATERM_20, AEXPR_19], 'expansion_244'),
      ], 
    AFACTOR: 
      [
        ([Operator('-', 'minus'), AFACTOR], 'expansion_524'),
        ([ATOM], 'expansion_525'),
      ], 
    NESTED_PROC: 
      [
        ([Bracket('{', 'lbrace'), PROCESS, Bracket('}', 'rbrace')], 'expansion_531'),
        ([ACTION], 'expansion_465'),
      ], 
    PROCESS_70: 
      [
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_333'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_20, AEXPR_19, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_424'),
      ], 
    COMMUNICATION_78_92_179_235: 
      [
        ([], 'communication_78_92_179_235'),
        ([Operator('->', 'arrow'), NESTED_PROC], 'expansion_170'),
        ([Keyword('at'), aperiot.lexer.Identifier, Operator('->', 'arrow'), NESTED_PROC], 'expansion_262'),
      ], 
    COMMUNICATION: 
      [
        ([Keyword('send'), EXPR, Keyword('to'), EXPR, COMMUNICATION_78_92_179_235], 'expansion_523'),
        ([Keyword('receive'), aperiot.lexer.Identifier, Keyword('from', 'fromkwd'), EXPR, COMMUNICATION_79_93_186_234], 'expansion_530'),
      ], 
    PROCESS_67_132_194_211_247: 
      [
        ([], 'process_67_132_194_211_247'),
        ([Keyword('for', 'forkwd'), EXPR, Keyword('in', 'inkwd'), EXPR], 'expansion_431'),
      ], 
    IMPORTS: 
      [
        ([], 'imports_action_1'),
        ([Keyword('import', 'importkwd'), aperiot.lexer.Identifier, IMPORTS], 'expansion_392'),
      ], 
    AEXPR_19: 
      [
        ([], 'aexpr_19'),
        ([Operator('+', 'plus'), AFACTOR, ATERM_20, AEXPR_19], 'expansion_271'),
        ([Operator('-', 'minus'), AFACTOR, ATERM_20, AEXPR_19], 'expansion_311'),
      ], 
    BINDINGS_5_115_148: 
      [
        ([], 'bindings_5_115_148'),
        ([Separator(',', 'comma'), aperiot.lexer.Identifier, Operator('=', 'eq'), EXPR, BINDINGS_5_115_148], 'expansion_416'),
      ], 
    DEF_LIST: 
      [
        ([], 'def_list_action_1'),
        ([DEF, DEF_LIST], 'expansion_477'),
      ], 
    BFACTOR: 
      [
        ([AFACTOR, ATERM_20, AEXPR_19, BATOM_52], 'expansion_443'),
        ([Operator('not', 'notop'), BFACTOR], 'expansion_286'),
      ], 
    EXPR: 
      [
        ([BFACTOR, BTERM_51, BEXPR_80], 'expansion_453'),
        ([Keyword('if', 'ifkwd'), BFACTOR, BTERM_51, BEXPR_80, Keyword('then'), EXPR, Keyword('else', 'elsekwd'), EXPR], 'expansion_459'),
        ([Keyword('cases'), EXPR, Bracket('{', 'lbrace'), EXPR, Operator('->', 'arrow'), EXPR, EXPR_CASES_28_100_174, Bracket('}', 'rbrace')], 'expansion_504'),
        ([Keyword('let'), aperiot.lexer.Identifier, Operator('=', 'eq'), EXPR, BINDINGS_5_115_148, Keyword('in', 'inkwd'), EXPR], 'expansion_417'),
      ], 
    EXPR_CASE_LIST_10_94_175: 
      [
        ([], 'expr_case_list_10_94_175'),
        ([Separator('|', 'bar'), EXPR, Operator('->', 'arrow'), EXPR, EXPR_CASE_LIST_10_94_175], 'expansion_407'),
      ], 
    RELATION: 
      [
        ([Operator('=', 'eq')], 'expansion_140'),
        ([Operator('!=', 'ne')], 'expansion_141'),
        ([Operator('<', 'lt')], 'expansion_142'),
        ([Operator('<=', 'le')], 'expansion_143'),
        ([Operator('>', 'gt')], 'expansion_138'),
        ([Operator('>=', 'ge')], 'expansion_139'),
      ], 
    PORT_LIST: 
      [
        ([], 'port_list_action_1'),
        ([aperiot.lexer.Identifier, NAME_LIST_1], 'expansion_118'),
      ], 
    MODULE: 
      [
        ([Keyword('module'), aperiot.lexer.Identifier, IMPORTS, DEF_LIST, MODULE_27_117_197_222], 'expansion_327'),
      ], 
    OPT_SEMICOLON: 
      [
        ([], 'opt_semicolon_action_1'),
        ([Separator(';', 'semicolon')], 'expansion_281'),
      ], 
    ACTION_16_95: 
      [
        ([], 'action_16_95'),
        ([Operator('->', 'arrow'), NESTED_PROC], 'expansion_362'),
      ], 
    ACTION_14: 
      [
        ([Operator(':=', 'assign'), EXPR, ACTION_14_97_195], 'expansion_464'),
        ([Bracket('[', 'lsqbra'), EXPR_LIST, Bracket(']', 'rsqbra'), ARGS], 'expansion_519'),
      ], 
    EXPR_CASES_28_100_174: 
      [
        ([], 'expr_cases_28_100_174'),
        ([Separator('|', 'bar'), EXPR, Operator('->', 'arrow'), EXPR, EXPR_CASES_28_100_174], 'expansion_505'),
      ], 
    CASE_LIST_46_82_198: 
      [
        ([], 'case_list_46_82_198'),
        ([Separator('|', 'bar'), EXPR, Operator('->', 'arrow'), NESTED_PROC, CASE_LIST_46_82_198], 'expansion_366'),
      ], 
    PROCESS_72_106_151_226: 
      [
        ([Keyword('else', 'elsekwd'), NESTED_PROC], 'expansion_94'),
        ([], 'process_72_106_151_226_1'),
      ], 
    FUNCTION_DEF_54_111_181: 
      [
        ([aperiot.lexer.Identifier, NAME_LIST_1, Bracket(')', 'rpar'), Separator(':', 'colon'), FUNC_BODY], 'expansion_134'),
        ([Bracket(')', 'rpar'), Separator(':', 'colon'), FUNC_BODY], 'expansion_412'),
      ], 
    ATOM_57: 
      [
        ([], 'atom_57'),
        ([Bracket('[', 'lsqbra'), AFACTOR, ATERM_20, AEXPR_19, Bracket(']', 'rsqbra')], 'expansion_430'),
        ([Bracket('(', 'lpar'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_429'),
      ], 
    ATOM_58: 
      [
        ([], 'atom_58'),
        ([Bracket('[', 'lsqbra'), AFACTOR, ATERM_20, AEXPR_19, Bracket(']', 'rsqbra')], 'expansion_302'),
      ], 
    PARAMS: 
      [
        ([], 'params_action_1'),
        ([Bracket('(', 'lpar'), aperiot.lexer.Identifier, NAME_LIST_1, Bracket(')', 'rpar')], 'expansion_400'),
      ], 
    EXPR_LIST_24: 
      [
        ([], 'expr_list_24'),
        ([Separator(',', 'comma'), EXPR_LIST], 'expansion_441'),
      ], 
    CONS_LIST_48: 
      [
        ([], 'cons_list_48'),
        ([Separator(';', 'semicolon'), EXPR, CONS_LIST_48], 'expansion_426'),
      ], 
    EXPR_LIST: 
      [
        ([], 'expr_list_action_1'),
        ([EXPR, EXPR_LIST_24], 'new_expr_list_action_2'),
      ], 
    PROCESS_66_141_149_230_254: 
      [
        ([], 'process_66_141_149_230_254'),
        ([Keyword('for', 'forkwd'), EXPR, Keyword('in', 'inkwd'), EXPR], 'expansion_409'),
      ], 
    BEXPR_80: 
      [
        ([], 'bexpr_80'),
        ([Operator('or', 'orop'), BFACTOR, BTERM_51, BEXPR_80], 'expansion_375'),
      ], 
    PROCESS_LIST_12_125: 
      [
        ([], 'process_list_12_125'),
        ([Separator(';', 'semicolon'), PROCESS, PROCESS_LIST_12_125], 'expansion_293'),
      ], 
    NAME_LIST_1: 
      [
        ([], 'name_list_1'),
        ([Separator(',', 'comma'), aperiot.lexer.Identifier, NAME_LIST_1], 'expansion_348'),
      ], 
    ARGS: 
      [
        ([], 'args_action_1'),
        ([Bracket('(', 'lpar'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_343'),
      ], 
    PROCESS_DEF_55: 
      [
        ([aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), PORT_LIST, Bracket(']', 'rsqbra'), PARAMS, Separator(':', 'colon'), BODY], 'expansion_516'),
        ([Keyword('main'), Bracket('[', 'lsqbra'), PORT_LIST, Bracket(']', 'rsqbra'), PARAMS, Separator(':', 'colon'), BODY], 'expansion_494'),
      ], 
    DEF: 
      [
        ([Keyword('function'), aperiot.lexer.Identifier, Bracket('(', 'lpar'), FUNCTION_DEF_54_111_181], 'expansion_475'),
        ([Keyword('process'), PROCESS_DEF_55], 'expansion_126'),
      ], 
    PARENTH_FORM_47_108_158_238_261_282: 
      [
        ([Bracket(')', 'rpar')], 'expansion_350'),
        ([Keyword('if', 'ifkwd'), BFACTOR, BTERM_51, BEXPR_80, Bracket(')', 'rpar')], 'expansion_376'),
      ], 
    ACTION_15_96: 
      [
        ([], 'action_15_96'),
        ([Operator('->', 'arrow'), NESTED_PROC], 'expansion_428'),
      ], 
    FUNC_BODY: 
      [
        ([Bracket('{', 'lbrace'), EXPR, Bracket('}', 'rbrace')], 'expansion_337'),
        ([EXPR], 'expansion_197'),
      ], 
    PROCESS_69: 
      [
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_446'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_20, AEXPR_19, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), NESTED_PROC], 'expansion_484'),
      ], 
    ACTION_14_97_195: 
      [
        ([], 'action_14_97_195'),
        ([Operator('->', 'arrow'), NESTED_PROC], 'expansion_535'),
      ], 
    IPROCESS_DEF: 
      [
        ([Keyword('process'), PROCESS_DEF_55], 'expansion_264'),
        ([Bracket('{', 'lbrace'), Keyword('process'), PROCESS_DEF_55, Bracket('}', 'rbrace')], 'expansion_511'),
      ], 
    COMMUNICATION_79_93_186_234: 
      [
        ([], 'communication_79_93_186_234'),
        ([Operator('->', 'arrow'), NESTED_PROC], 'expansion_309'),
        ([Keyword('at'), aperiot.lexer.Identifier, Operator('->', 'arrow'), NESTED_PROC], 'expansion_196'),
      ], 
    NDEF_LIST_0: 
      [
        ([], 'ndef_list_0'),
        ([DEF, NDEF_LIST_0], 'expansion_274'),
      ], 
    CASES_17_140_160: 
      [
        ([], 'cases_17_140_160'),
        ([Separator('|', 'bar'), EXPR, Operator('->', 'arrow'), NESTED_PROC, CASES_17_140_160], 'expansion_528'),
      ], 
    ATERM_20: 
      [
        ([], 'aterm_20'),
        ([Operator('*', 'times'), AFACTOR, ATERM_20], 'expansion_403'),
        ([Operator('/', 'div'), AFACTOR, ATERM_20], 'expansion_401'),
        ([Operator('%', 'mod'), AFACTOR, ATERM_20], 'expansion_402'),
      ], 
    ATOM: 
      [
        ([LITERAL], 'expansion_328'),
        ([aperiot.lexer.Identifier, ATOM_57], 'new_atom_action_2'),
        ([Bracket('(', 'lpar'), PARENTH_FORM_47, ATOM_58], 'expansion_476'),
      ], 
  }

start = MODULE


