
import aperiot.lexer


# Non-terminal symbol names

ACTION_12_79 = 'ACTION_12_79'
ACTION = 'ACTION'
CASES = 'CASES'
BATOM_47 = 'BATOM_47'
PROCESS = 'PROCESS'
PROCESS_57_85_170_182_222_245_294 = 'PROCESS_57_85_170_182_222_245_294'
PARENTH_FORM_42 = 'PARENTH_FORM_42'
LITERAL = 'LITERAL'
CASES_15_118_146_204_232_261_300_321_336 = 'CASES_15_118_146_204_232_261_300_321_336'
PROCESS_DEF_63 = 'PROCESS_DEF_63'
AFACTOR = 'AFACTOR'
COMMUNICATION = 'COMMUNICATION'
COMMUNICATION_64_112_125_185 = 'COMMUNICATION_64_112_125_185'
IMPORTS = 'IMPORTS'
PROCESS_55 = 'PROCESS_55'
PROCESS_54 = 'PROCESS_54'
AEXPR_17 = 'AEXPR_17'
BTERM_46 = 'BTERM_46'
COMMUNICATION_65_111_123_203 = 'COMMUNICATION_65_111_123_203'
BFACTOR = 'BFACTOR'
ATOM_45 = 'ATOM_45'
ATOM_44 = 'ATOM_44'
DEF_LIST = 'DEF_LIST'
PROCESS_52_83_142_201 = 'PROCESS_52_83_142_201'
RELATION = 'RELATION'
PORT_LIST = 'PORT_LIST'
ACTION_11_80_134 = 'ACTION_11_80_134'
BEXPR_66 = 'BEXPR_66'
MODULE = 'MODULE'
BINDINGS_5_99_156 = 'BINDINGS_5_99_156'
ACTION_11 = 'ACTION_11'
PARENTH_FORM_42_91_129_187_227_256 = 'PARENTH_FORM_42_91_129_187_227_256'
CASE_LIST_41_70_136_176_233_247 = 'CASE_LIST_41_70_136_176_233_247'
ACTION_13_78 = 'ACTION_13_78'
EXPR_LIST_20 = 'EXPR_LIST_20'
PARAMS = 'PARAMS'
EXPR_LIST = 'EXPR_LIST'
MODULE_23_104_145_184_230 = 'MODULE_23_104_145_184_230'
ATERM_18 = 'ATERM_18'
PROCESS_LIST_9 = 'PROCESS_LIST_9'
NAME_LIST_1 = 'NAME_LIST_1'
PARENTH_FORM_42_91 = 'PARENTH_FORM_42_91'
ARGS = 'ARGS'
DEF = 'DEF'
PROCESS_51_84_144_186 = 'PROCESS_51_84_144_186'
IPROCESS_DEF = 'IPROCESS_DEF'
NDEF_LIST_0 = 'NDEF_LIST_0'
ATOM = 'ATOM'

rules = \
  {
    ACTION_12_79: 
      [
        ([aperiot.lexer.Newline], 'expansion_770'),
        ([Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_780'),
      ], 
    ACTION: 
      [
        ([COMMUNICATION], 'expansion_413'),
        ([aperiot.lexer.Identifier, ACTION_11], 'new_expansion_52'),
        ([Keyword('print', 'printkwd'), BFACTOR, BTERM_46, BEXPR_66, ACTION_12_79], 'expansion_527'),
        ([Keyword('wait'), BFACTOR, BTERM_46, BEXPR_66, ACTION_13_78], 'expansion_528'),
      ], 
    CASES: 
      [
        ([BFACTOR, BTERM_46, BEXPR_66, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_588'),
        ([aperiot.lexer.Newline, aperiot.lexer.Indent, BFACTOR, BTERM_46, BEXPR_66, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, aperiot.lexer.Dedent, CASES_15_118_146_204_232_261_300_321_336], 'expansion_622'),
      ], 
    BATOM_47: 
      [
        ([], 'batom_47'),
        ([RELATION, AFACTOR, ATERM_18, AEXPR_17], 'expansion_765'),
      ], 
    PROCESS: 
      [
        ([Keyword('nil'), aperiot.lexer.Newline], 'expansion_389'),
        ([Keyword('done'), aperiot.lexer.Newline], 'expansion_270'),
        ([ACTION], 'expansion_484'),
        ([Keyword('par', 'parallel'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, PROCESS_51_84_144_186], 'expansion_767'),
        ([Keyword('seq', 'sequence'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, PROCESS_52_83_142_201], 'expansion_482'),
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_748'),
        ([Keyword('async'), PROCESS_54], 'new_expansion_12'),
        ([Keyword('sync'), PROCESS_55], 'new_expansion_13'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_18, AEXPR_17, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_743'),
        ([Keyword('if', 'ifkwd'), BFACTOR, BTERM_46, BEXPR_66, Keyword('then'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, PROCESS_57_85_170_182_222_245_294], 'expansion_531'),
        ([Keyword('let'), aperiot.lexer.Identifier, Operator('=', 'eq'), BFACTOR, BTERM_46, BEXPR_66, BINDINGS_5_99_156, Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_532'),
        ([Keyword('match'), BFACTOR, BTERM_46, BEXPR_66, Keyword('with'), CASES], 'expansion_686'),
        ([DEF, NDEF_LIST_0, Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_781'),
        ([Keyword('timeout'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, Keyword('after'), BFACTOR, BTERM_46, BEXPR_66, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_771'),
        ([Keyword('do'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, Keyword('interrupt'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_668'),
      ], 
    PROCESS_57_85_170_182_222_245_294: 
      [
        ([Keyword('else', 'elsekwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_789'),
        ([], 'process_57_85_170_182_222_245_294_1'),
      ], 
    PARENTH_FORM_42: 
      [
        ([Bracket(')', 'rpar')], 'expansion_627'),
        ([BFACTOR, BTERM_46, BEXPR_66, PARENTH_FORM_42_91], 'expansion_535'),
      ], 
    LITERAL: 
      [
        ([Operator('unit')], 'expansion_136'),
        ([aperiot.lexer.NumberLiteral], 'expansion_134'),
        ([Operator('true')], 'expansion_135'),
        ([Operator('false')], 'expansion_256'),
        ([aperiot.lexer.StringLiteral], 'expansion_255'),
        ([Keyword('channel', 'channelkwd')], 'expansion_254'),
        ([Keyword('async'), Keyword('channel', 'channelkwd')], 'expansion_253'),
        ([Keyword('sync'), Keyword('channel', 'channelkwd')], 'expansion_433'),
      ], 
    CASES_15_118_146_204_232_261_300_321_336: 
      [
        ([], 'cases_15_118_146_204_232_261_300_321_336'),
        ([Separator('|', 'bar'), BFACTOR, BTERM_46, BEXPR_66, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, CASE_LIST_41_70_136_176_233_247], 'expansion_753'),
      ], 
    PROCESS_DEF_63: 
      [
        ([aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), PORT_LIST, Bracket(']', 'rsqbra'), PARAMS, Separator(':', 'colon'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_793'),
        ([Keyword('main'), Bracket('[', 'lsqbra'), PORT_LIST, Bracket(']', 'rsqbra'), PARAMS, Separator(':', 'colon'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_706'),
      ], 
    AFACTOR: 
      [
        ([Operator('-', 'minus'), AFACTOR], 'expansion_786'),
        ([ATOM], 'expansion_787'),
      ], 
    COMMUNICATION: 
      [
        ([Keyword('send'), BFACTOR, BTERM_46, BEXPR_66, Keyword('to'), BFACTOR, BTERM_46, BEXPR_66, COMMUNICATION_64_112_125_185], 'expansion_683'),
        ([Keyword('receive'), aperiot.lexer.Identifier, Keyword('from', 'fromkwd'), BFACTOR, BTERM_46, BEXPR_66, COMMUNICATION_65_111_123_203], 'expansion_541'),
      ], 
    COMMUNICATION_64_112_125_185: 
      [
        ([aperiot.lexer.Newline], 'expansion_488'),
        ([Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_759'),
        ([Keyword('at'), aperiot.lexer.Identifier, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_737'),
      ], 
    IMPORTS: 
      [
        ([], 'imports_action_1'),
        ([Keyword('import', 'importkwd'), aperiot.lexer.Identifier, aperiot.lexer.Newline, IMPORTS], 'expansion_695'),
      ], 
    PROCESS_55: 
      [
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_647'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_18, AEXPR_17, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_651'),
      ], 
    PROCESS_54: 
      [
        ([Keyword('channel', 'channelkwd'), aperiot.lexer.Identifier, NAME_LIST_1, Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_742'),
        ([Keyword('channels', 'channelskwd'), aperiot.lexer.Identifier, Bracket('[', 'lsqbra'), AFACTOR, ATERM_18, AEXPR_17, Bracket(']', 'rsqbra'), Keyword('in', 'inkwd'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_806'),
      ], 
    AEXPR_17: 
      [
        ([], 'aexpr_17'),
        ([Operator('+', 'plus'), AFACTOR, ATERM_18, AEXPR_17], 'expansion_510'),
        ([Operator('-', 'minus'), AFACTOR, ATERM_18, AEXPR_17], 'expansion_366'),
      ], 
    BTERM_46: 
      [
        ([], 'bterm_46'),
        ([Operator('and', 'andop'), BFACTOR, BTERM_46], 'expansion_393'),
      ], 
    COMMUNICATION_65_111_123_203: 
      [
        ([aperiot.lexer.Newline], 'expansion_186'),
        ([Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_425'),
        ([Keyword('at'), aperiot.lexer.Identifier, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_630'),
      ], 
    BFACTOR: 
      [
        ([AFACTOR, ATERM_18, AEXPR_17, BATOM_47], 'expansion_660'),
        ([Operator('not', 'notop'), BFACTOR], 'expansion_802'),
      ], 
    ATOM_45: 
      [
        ([], 'atom_45'),
        ([Bracket('[', 'lsqbra'), AFACTOR, ATERM_18, AEXPR_17, Bracket(']', 'rsqbra')], 'expansion_751'),
      ], 
    ATOM_44: 
      [
        ([], 'atom_44'),
        ([Bracket('[', 'lsqbra'), AFACTOR, ATERM_18, AEXPR_17, Bracket(']', 'rsqbra')], 'expansion_450'),
        ([Bracket('(', 'lpar'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_652'),
      ], 
    DEF_LIST: 
      [
        ([], 'def_list_action_1'),
        ([DEF, DEF_LIST], 'expansion_231'),
      ], 
    PROCESS_52_83_142_201: 
      [
        ([PROCESS, PROCESS_LIST_9, aperiot.lexer.Dedent], 'expansion_732'),
        ([aperiot.lexer.Dedent, Keyword('for', 'forkwd'), BFACTOR, BTERM_46, BEXPR_66, Keyword('in', 'inkwd'), BFACTOR, BTERM_46, BEXPR_66, aperiot.lexer.Newline], 'expansion_762'),
      ], 
    RELATION: 
      [
        ([Operator('=', 'eq')], 'expansion_284'),
        ([Operator('!=', 'ne')], 'expansion_286'),
        ([Operator('<', 'lt')], 'expansion_285'),
        ([Operator('<=', 'le')], 'expansion_280'),
        ([Operator('>', 'gt')], 'expansion_279'),
        ([Operator('>=', 'ge')], 'expansion_204'),
      ], 
    PORT_LIST: 
      [
        ([], 'port_list_action_1'),
        ([aperiot.lexer.Identifier, NAME_LIST_1], 'expansion_180'),
      ], 
    ACTION_11_80_134: 
      [
        ([aperiot.lexer.Newline], 'expansion_321'),
        ([Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_698'),
      ], 
    BEXPR_66: 
      [
        ([], 'bexpr_66'),
        ([Operator('or', 'orop'), BFACTOR, BTERM_46, BEXPR_66], 'expansion_556'),
      ], 
    MODULE: 
      [
        ([Keyword('module'), aperiot.lexer.Identifier, aperiot.lexer.Newline, IMPORTS, DEF_LIST, MODULE_23_104_145_184_230], 'expansion_406'),
      ], 
    BINDINGS_5_99_156: 
      [
        ([], 'bindings_5_99_156'),
        ([aperiot.lexer.Newline, Operator('and', 'andop'), aperiot.lexer.Identifier, Operator('=', 'eq'), BFACTOR, BTERM_46, BEXPR_66, BINDINGS_5_99_156], 'expansion_557'),
      ], 
    ACTION_11: 
      [
        ([Operator(':=', 'assign'), BFACTOR, BTERM_46, BEXPR_66, ACTION_11_80_134], 'expansion_561'),
        ([Bracket('[', 'lsqbra'), EXPR_LIST, Bracket(']', 'rsqbra'), ARGS, aperiot.lexer.Newline], 'expansion_340'),
      ], 
    PARENTH_FORM_42_91_129_187_227_256: 
      [
        ([Bracket(')', 'rpar')], 'expansion_766'),
        ([Keyword('if', 'ifkwd'), BFACTOR, BTERM_46, BEXPR_66, Bracket(')', 'rpar')], 'expansion_769'),
      ], 
    CASE_LIST_41_70_136_176_233_247: 
      [
        ([], 'case_list_41_70_136_176_233_247'),
        ([Separator('|', 'bar'), BFACTOR, BTERM_46, BEXPR_66, Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent, CASE_LIST_41_70_136_176_233_247], 'expansion_756'),
      ], 
    ACTION_13_78: 
      [
        ([], 'action_13_78'),
        ([Operator('->', 'arrow'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_717'),
      ], 
    EXPR_LIST_20: 
      [
        ([], 'expr_list_20'),
        ([Separator(',', 'comma'), EXPR_LIST], 'expansion_696'),
      ], 
    PARAMS: 
      [
        ([], 'params_action_1'),
        ([Bracket('(', 'lpar'), aperiot.lexer.Identifier, NAME_LIST_1, Bracket(')', 'rpar')], 'expansion_642'),
      ], 
    EXPR_LIST: 
      [
        ([], 'expr_list_action_1'),
        ([BFACTOR, BTERM_46, BEXPR_66, EXPR_LIST_20], 'expansion_571'),
      ], 
    MODULE_23_104_145_184_230: 
      [
        ([], 'module_23_104_145_184_230'),
        ([Keyword('main'), aperiot.lexer.Newline, aperiot.lexer.Indent, PROCESS, aperiot.lexer.Dedent], 'expansion_691'),
      ], 
    ATERM_18: 
      [
        ([], 'aterm_18'),
        ([Operator('*', 'times'), AFACTOR, ATERM_18], 'expansion_377'),
        ([Operator('/', 'div'), AFACTOR, ATERM_18], 'expansion_461'),
        ([Operator('%', 'mod'), AFACTOR, ATERM_18], 'expansion_379'),
      ], 
    PROCESS_LIST_9: 
      [
        ([], 'process_list_9'),
        ([PROCESS, PROCESS_LIST_9], 'expansion_302'),
      ], 
    NAME_LIST_1: 
      [
        ([], 'name_list_1'),
        ([Separator(',', 'comma'), aperiot.lexer.Identifier, NAME_LIST_1], 'expansion_615'),
      ], 
    PARENTH_FORM_42_91: 
      [
        ([Bracket(')', 'rpar')], 'expansion_508'),
        ([Separator(',', 'comma'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_507'),
        ([Keyword('for', 'forkwd'), BFACTOR, BTERM_46, BEXPR_66, Keyword('in', 'inkwd'), BFACTOR, BTERM_46, BEXPR_66, PARENTH_FORM_42_91_129_187_227_256], 'expansion_645'),
      ], 
    ARGS: 
      [
        ([], 'args_action_1'),
        ([Bracket('(', 'lpar'), EXPR_LIST, Bracket(')', 'rpar')], 'expansion_420'),
      ], 
    DEF: 
      [
        ([Keyword('function'), aperiot.lexer.Identifier, Bracket('(', 'lpar'), aperiot.lexer.Identifier, NAME_LIST_1, Bracket(')', 'rpar'), Separator(':', 'colon'), aperiot.lexer.Newline, aperiot.lexer.Indent, BFACTOR, BTERM_46, BEXPR_66, aperiot.lexer.Newline, aperiot.lexer.Dedent], 'expansion_723'),
        ([Keyword('process'), PROCESS_DEF_63], 'expansion_184'),
      ], 
    PROCESS_51_84_144_186: 
      [
        ([PROCESS, PROCESS_LIST_9, aperiot.lexer.Dedent], 'expansion_635'),
        ([aperiot.lexer.Dedent, Keyword('for', 'forkwd'), BFACTOR, BTERM_46, BEXPR_66, Keyword('in', 'inkwd'), BFACTOR, BTERM_46, BEXPR_66, aperiot.lexer.Newline], 'expansion_726'),
      ], 
    IPROCESS_DEF: 
      [
        ([Keyword('process'), PROCESS_DEF_63], 'expansion_382'),
        ([aperiot.lexer.Indent, Keyword('process'), PROCESS_DEF_63, aperiot.lexer.Dedent], 'expansion_464'),
      ], 
    NDEF_LIST_0: 
      [
        ([], 'ndef_list_0'),
        ([DEF, NDEF_LIST_0], 'expansion_785'),
      ], 
    ATOM: 
      [
        ([LITERAL], 'expansion_251'),
        ([aperiot.lexer.Identifier, ATOM_44], 'new_atom_action_2'),
        ([Bracket('(', 'lpar'), PARENTH_FORM_42, ATOM_45], 'expansion_729'),
      ], 
  }

start = MODULE


