#! /usr/bin/python

# Post-install script

import sys

def generate_parser(name):
    print "* Generating kiltera parser"
    from aperiot.parsergen import build_parser
    from aperiot.parsergen import save_parser
    import kiltera
    dir = kiltera.__path__[0]
    sys.path.append(dir)
    parser = build_parser(name, verbose=True)
    print "* kiltera parser generated"
    print "* Saving kiltera parser"
    save_parser(parser, dir, name, verbose=True)
    print "* kiltera parser saved in '" + dir + "'"

def main():
    print "* Executing post-install script"
    global generate_parser   # Strange: this hack added because python was complaining
    try:
        generate_parser('kiltera_syn')
        generate_parser('kiltera_syn_original')
    except ImportError, e:
        print "* (Post-install error: Import error) "+str(e)
    print "* Post-install script finished"

if __name__ == '__main__':
    main()

